// Bibliotheken zum Einbinden (Zufallszahlen, Ein-Ausgabe)
#include <cstdlib>
#include <stdio.h>
#include <stdlib.h>  
#include <iostream>
#include "math.h"
#include "hilf.h"
#include "vector.h"
#include "vector2.h"
#include "integration.h"
#include "evalfunction.h"
#include "adaptiv.h"
#include "graphik.h"

using namespace std;

// Newton-Cotes Formeln
int main()
{ 
  int m,nmax;
  double numintegral,exaktintegral,eps;
  double* mesh;
  double* x;
  double* y;
  char type;
 
  cout <<"Wahl der Funktion: (sin x/x,x^5,tan x,sqrt(1+x^2),log(1+x),|sin(3x-2)|,sin(1/(x+0.01)),sqrt(x)"<<endl;
  cout <<"s/p/t/w/l/b/h/q"<<endl;
  cin >> type;
  exactint(type,&exaktintegral);
  cout <<"Maximaler Speicher?"<< endl;
  cin>> nmax;
  cout <<"Genauigkeit?"<< endl;
  cin>> eps;
  mesh=(double*)malloc(2*nmax*sizeof(double)); 
  adaptiv(mesh,&m,&numintegral,eps,type,nmax);
  cout <<"Wert:"<<numintegral<<endl;
  cout <<"Fehler:"<<numintegral-exaktintegral<<endl;
  // Graphische Aufbereitung der Netzes
  x=(double*)malloc(m*sizeof(double));   
  y=(double*)malloc(m*sizeof(double));
  vdcopy(m,x,1,mesh,2);
  vdcopy(m,y,1,&mesh[1],2);
  vdminus(m,y,1,x,1,y,1);
  PlotResults1DLog(x,y,m);
  ausgabe(y,m);
  ausgabe(x,m);
  free(mesh); 
  free(x);
  free(y);
  return 0;
}
